/*
#NAME
#  Copy - copy file to file.
#
#SYNOPSIS
#  Copy [option].. file1 file2
#
#DESCRIPTION
#
#OPTIONS
#
#SEE ALSO
#
#BUGS
#
#AUTHOR
#  John Chambers <jc@trillian.mit.edu>
*/

#include "D.h"
#include "sys_fcntl.h"

char  buf[BUFSIZ];
long  bufsiz = BUFSIZ;
long  bytecount = 0;
char* ifile = 0;
char* ofile = 0;
int   ifd = -1;
int   ofd = -1;

main(ac,av)
	int   ac;
	char**av;
{	int   a, f, r, w;

:1	ac = Dinit(ac,av);

	for (a=1; a<ac; a++) {
		switch (av[a][0]) {
		case '+':
		case '-':
:1			V1 "Unknown option \"%s\" ignored.",av[a] V;
			continue;
		default:
			if (!ifile) {
				ifile = av[a];
:2				V2 "Input  file: \"%s\"",ifile V;
			} else if (!ofile) {
				ofile = av[a];
:2				V2 "Output file: \"%s\"",ofile V;
:2			} else {
:2				V2 "Unexpected arg \"%s\" ignored.",av[a] V;
			}
		}
	}
	if ((ifd = Open(ifile,O_RDONLY,0)) < 0) {
		V1 "Can't read \"%s\" [Err %d=%s=%s]",ifile,Errinfo V;
		Exit(errno);
	}
	if ((ofd = Open(ofile,O_WRONLY|O_CREAT,0666)) < 0) {
		V1 "Can't write \"%s\" [Err %d=%s=%s]",ofile,Errinfo V;
		Exit(errno);
	}
	while ((r = Read(ifd,buf,bufsiz)) > 0) {
:5		V5 "Got %s",Dspp(buf) V;
		w = Write(ofd,buf,r);
		if (w < r) {
			exitstat = errno;
:1			V1 "Write of only %d of %d bytes [Err %d=%s=%s]",w,r,Errinfo V;
			Fail;
		}
		bytecount += w;
	}
	if (r < 0) {
		exitstat = errno;
	}
done:
fail:
:2	V2 "Exit status %d.",exitstat V;
	Exit(exitstat);
}
