:i	static char d_newfile_sccs_id[] = "%W% %G%";
:1#include "D_s.h"
:1#include "mem.h"
:1#include "str.h"

extern void DmpFile();
extern void DmpFiles();
/*
* Return an empty file slot.  The only reason for failure is if we're
* out of memory.
*/
File* d_fileslot(name)
	char* name;
{	File* fp;
:f	Fenter("d_fileslot");
	for (fp = openfiles; fp; fp = fp->next) {
:6		V6 "fp=%08lX flgs=%X",fp,fp->flgs V;
		if (!(fp->flgs & File_OPEN)) {
:5			V5 "fp=%08lX flgs=%X not open.",fp,fp->flgs V;
			return fp;
		}
	}
:5	V5 "No free file slots." V;
	NewChunkMF(fp,File,"File");
	MakStrMF(&fp->name,name,-1,"File name");
	fp->fh     = ++openfilemax;
:5	V5 "fp=%08lX fh=%d name=%s",fp,fp->fh,DspSV(fp->name) V;
	fp->lfd    = -1;
	fp->rfd    = -1;
	fp->addr   = 0;
	fp->flgs   = 0;
	fp->port   = 0;
	fp->ipad   = 0;
	fp->reads  = 0;
	fp->writes = 0;
	fp->prev   = openfilez;
	fp->next   = 0;
	openfilez->next = fp;	/* Insert at end of openfile list */
	openfilez  = fp;
	if (Vlvl > 4) DmpFile(fp);
:f	Fexit;
	return fp;
fail:
:1	V1 "d_fileslot: Can't allocate new file slot." V;
:f	Fexit;
	return 0;
}

/*
* Note some facts about a newly-opened file. The nominal return value,
* r, is an index into the openfiles list.  We make a copy of the name,
* in case the caller wants to re-use the  space.   Note  that  we  are
* careful  to  free  the previous name, if it still exists, to prevent
* memory leaks; the close routines leave the  old  name  around  as  a
* relic  so that it can be used in messages.  This is a small waste of
* memory, but it has at times been useful after a file is closed.
*/
File* d_newfile(fl,f,n,m)
	int   fl;		/* Flags */
	int   f;		/* File number */
	char* n;		/* File name */
	char* m;		/* Message describing file */
{	File* r=0;		/* Index into openfiles list */
	int   i;
	Fenter("d_newfile");
:6	V6 "d_newfile(0%o,%d,\"%s\",\"%s\") ...",fl,f,N(n),N(m) V;
:6	if (Vlvl>5) d_chkfiles("start d_newfile");
	if (f > OPEN_MAX) {
:2		V2 "File f=%d >= OPEN_MAX=%d.",f,OPEN_MAX V;
		Fail;
	}
	while (openfilemax < f) {
:6		V6 "File %d descriptor must be created ...",f V;
		NewChunkMF(r,File,"openfile");
		if (openfilez) {
:6			V6 "File %d added to list ...",f V;
			openfilez->next = r;
		} else {
:6			V6 "File %d first in list ...",f V;
			openfiles = r;
		}
		openfilez = r;
		r->lfd = ++openfilemax;
	}
	for (i=0, r=openfiles; i!=f && r; i++, r = r->next)
:6		V6s "openfile %d: %lX lfd=%d flgs=%X \"%s\"",i,r,r->lfd,r->flgs,N(r->name.v) V;
		;
	if (!r) {
:3		V3 "Can't find File %d descriptor.",f V;
		Fail;
	}
:6	V6 "File %d descriptor is %lX.",f,r V;
	if (fl & File_REMOTE) {
:3		V3s "File %d is remote.",f V;
:3		V3s m_nothere V;
		r = 0;
		Fail;
	}
:6	V6s "File %d is local.",f V;
	if (! n) n = m_unknown;
	if (! m) m = n;
	MakStrMF(&r->name,n,-1,m);
:8	V8s "File %d name=[%d/%d/%08X/%08X] %s",f,
:8		r->name.l,
:8		r->name.m,
:8		r->name.v,
:8		r->name.p,
:8		DspSV(r->name) V;
	r->flgs = fl | File_OPEN;
	r->lfd  =
	r->rfd  = f;
	r->addr = 0;		/* No data so far */
	if (openfilemax < f)			/* Keep track of the highest open file */
		openfilemax = f;
:6	if (Vlvl>5) d_chkfiles("after d_newfile success");
:8	V8s "Return %lX [Err %d=%s=%s]",r,Errinfo V;
	Fexit;
	return r;
fail:
:6	if (Vlvl>5) d_chkfiles("after d_newfile failure");
:2	V2 "### Failed for %s",Dsps(n,-1) V;
	Fexit;
	return 0;
}

File* d_openfile(f)
{	int   i;
	File* fp;
:6	V6s "d_openfile(%d) ...",f V;
:6	if (Vlvl>5) d_chkfiles("Start d_openfile");
	for (i=0, fp=openfiles; i!=f && fp; i++, fp = fp->next)
:6		V7s "openfile %d: %lX lfd=%d flgs=%X \"%s\"",i,fp,fp->lfd,fp->flgs,N(fp->name.v) V;
		;
:7	if ( fp) V7s "d_openfile(%d)=%lX",f,fp V;
:7	if (!fp) V2s "d_openfile(%d) failed.",f V;
:6	if ( fp) V6s "openfile %d: %lX lfd=%d flgs=%X \"%s\"",i,fp,fp->lfd,fp->flgs,N(fp->name.v) V;
:6	if (Vlvl>5) d_chkfiles("Finish d_openfile");
	return(i==f ? fp : 0);
}

d_chkfiles(m)
	char*  m;
{	int    i;
	File*  p;
	for (i=0, p=openfiles; p; i++, p = p->next) {
:7		V7s "--- openfile %d: %lX lfd=%d flgs=%X \"%s\" [%s]",i,p,p->lfd,p->flgs,N(p->name.v),m V;
		if (p->fh != i)
			V1 "### openfile %d: %lX Bad fh=%d lfd=%d flgs=%X \"%s\" [%s]"
				,i,p,p->fh,p->lfd,p->flgs,N(p->name.v),m V;
	}
:6	V6s "--- openfile list contains %d files.",i V;
}

void
DmpFile(fp)
	File* fp;
{
:2	if (!fp) {
:2		V2 "DmpFile(%08lX) called!!!",fp V;
		return;
:2	}
:2	V1 "File %d [%08lX]: %s"
:2		,fp->fh,fp,DspSV(fp->name) V;
:2	V1 "\tlfd=%d rfd=%d reads=%d writes=%d flgs=%X"
:2		,fp->lfd,fp->rfd,fp->reads,fp->writes,fp->flgs V;
:2	V1 "\tnext=%08lX prev=%08lX srvr=%08lX"
:2		,fp->next,fp->prev,fp->srvr V;
}

void DmpFiles(msg)
	char* msg;
{	File* fp;
	V1 "+++ openfiles %s",msg V;
	V1 "\topenfiles=%08lX openfilez=%08lX",openfiles,openfilez V;
	for (fp = openfiles; fp; fp = fp->next) {
		DmpFile(fp);
	}
	V1 "--- openfiles %s",msg V;
}

File* d_findfile(f)
	int   f;
{	File* fp;
:f	Fenter("d_findfile");
	for (fp = openfiles; fp; fp = fp->next) {
		if (fp->fh == f) {
			return fp;
		}
	}
fail:
:f	Fexit;
	return 0;
}
