#ifndef abbr_h
#define abbr_h
/*
* Here is a list of useful abbreviations, to save typing and make  the
* code  somewhat  more readable.  We also do some defining to iron out
* problems with mismatched names from different sources.
*
* The mkdep script excludes this file from its  dependency  lists,  so
* you can add things here without worrying about a complete recompile.
*/
#ifndef   V_h
#include "D.h"
#endif
/*
* Here are some pseudo-types (abbreviations) that come in  handy  when
* we  want  to  specify types by the number of bits.  This offends the
* theoreticians, of course, but when writing comm code, you often have
* no alternative.
*/
#ifndef	I8
#define	I8	char
#endif
#ifndef	I16
#define	I16	short
#endif
#ifndef	I32
#define	I32	long
#endif
#ifndef	U8
#define	U8	unsigned char
#endif
#ifndef	U16
#define	U16	unsigned short
#endif
#ifndef	U32
#define	U32	unsigned long
#endif
/*
* Some abbreviations for common structures, to save typing.
*/
#ifndef	HOST
#define	HOST	struct hostent
#endif
#ifndef	INAD
#define	INAD	struct in_addr
#endif
#ifndef	IP32	/* 32-bit IP address */
#define	IP32	unsigned long
#endif
#ifndef	IPKT
#define	IPKT	struct ip
#endif
#ifndef	SKAD	/* Generic socket structure */
#define	SKAD	struct sockaddr
#endif
#ifndef	SKDN	/* DECnet socket structure */
#define	SKDN	struct dn_naddr
#endif
#ifndef	SKin	/* Internet socket structure */
#define	SKin	struct sockaddr_in
#endif
#ifndef	STat	/* Unix file-status structure */
#define	STat	struct stat
#endif

/*
* Here are some definitions to  straighten  out  some  of  the  naming
* conventions  used  in  the  SPANet CM record structures.  We do this
* mostly to simplify the generation of similar chunks of code when  we
* can't quite figure out how to subroutinize it; simplifying typing is
* also another motive. Also, people keep changing the names of fields;
* using  the  simpler names will make the code somewhat immune to such
* changes. Note that most of these definitions reduce a longer name to
* a shorter one; the *.i files will thus show the shorter names.
*/
#define	CommandStat	cmdstat
#define	CommandStatus	cmdstat
#define	DeviceID	devid
#define	DeviceStat	devstat
#define	DeviceStatus	devstat
#define	DeviceType	devtype
#define	EIMID	devid
#define	FaultID	fltid
#define	ICCID	devid
#define	MessageType	type
#define	NumDevPorts	numports
#define	NumDevs	numdevs
#define	NumEIMPorts	numports
#define	NumEIMs	numdevs
#define	NumSFMs	numdevs
#define	NumTMGs	numdevs
#define	PortID	portid
#define	PortType	porttype
#define	RequestID	reqid
#define	SFMDeviceID	devid
#define	SFMID	devid
#define	SFMOutputPortID portid
#define	SFMPortType	porttype
#define	SFMoutputPortID portid
#define	StatID	statid
#define	StatusID	statid
#define	TMGID	devid
#define	tmgid	devid

/*#define	CM4_CM_Stat_progress	CM4_CM_Fault_Stat_progress */
/*#define	CT4_CM_Stat_progress	CT4_CM_Fault_Stat_progress */
/*#define	Cd4_CM_Stat_progress	Cd4_CM_Fault_Stat_progress */
/*#define	CM4_CM_Stat_request	CM4_CM_Fault_Stat_request */
/*#define	CT4_CM_Stat_request	CT4_CM_Fault_Stat_request */
#define	CM4_Cabinet_Stat_request	CM4_ND_Stat_request
/*#define	CM4_Call_Setup_progress	CM4_Call_Setup_progress */
/*#define	CT4_Call_Setup_progress	CT4_Call_Setup_progress */
/*#define	CT4_Call_Setup_request	CT4_Call_Setup_request */
/*#define	CT4_Conn_Info_Add_request	CT4_Conn_Info_Add_request */
/*#define	CT4_Conn_Info_Delete_request	CT4_Conn_Info_Delete_request */
#define	DM4_Define_Prof_request	DM4_Prof_request
#define	DM4_Define_VPC_request	DM4_VPC_request
#define	CT4_GET_TRIP_POINT_progress	CT4_Get_Trip_Points_progress
#define	CT4_GET_TRIP_POINT_request	CT4_Get_Trip_Points_request
#define	CA4_LTIM_DTG_IF_Stat_progress	CA4_LTIM_DTG_TRUNK_IF_Stat_progress
#define	CM4_LTIM_DTG_IF_Stat_progress	CM4_LTIM_DTG_TRUNK_IF_Stat_progress
#define	CS4_LTIM_DTG_IF_Stat_progress	CS4_LTIM_DTG_TRUNK_IF_Stat_progress
#define	CT4_LTIM_DTG_TRUNK_IF_Stat_progress	CT4_LTIM_DTG_IF_Stat_progress
#define	CA4_LTIM_T1_IF_Stat_progress	CA4_LTIM_T1_TRUNK_IF_Stat_progress
#define	CM4_LTIM_T1_IF_Stat_progress	CM4_LTIM_T1_TRUNK_IF_Stat_progress
#define	CS4_LTIM_T1_IF_Stat_progress	CS4_LTIM_T1_TRUNK_IF_Stat_progress
#define	CT4_LTIM_T1_TRUNK_IF_Stat_progress	CT4_LTIM_T1_IF_Stat_progress
#define	CM4_Output_Stat_notify	CM4_Output_Stat_reply
#define	CS4_Output_Stat_notify	CS4_Output_Stat_reply
#define	DM4_SFM_Close_Port_request	DM4_SFM_Open_Port_request
#define	DM4_Update_Prof_request	DM4_Prof_request
#define	DM4_Update_VPC_request	DM4_VPC_request

#define GsweimptOperStatus GsweimptOperStat

#endif
