#include "D.h"

#define RPLMAX 1000
global long RplMax   = RPLMAX;
global Str  SrvrReq  = {0};	/* one server request */
global Str  SrvrRpl  = {0};	/* one server reply */

/*
* Send a request to a server and wait for a reply.
* We discard replies until we get one with the requested
* initial string, if any.  Maybe we also need a timeout.
*/
Str* daReqRpl(sp,rq,dp,rp,ip)
	Srvr* sp;	/* Server */
	Str*  rq;	/* Request to send */
	Str*  dp;	/* Additional data to send */
	Str*  rp;	/* Reply to be filled in */
	char* ip;	/* Required initial substring */
{	int   n;
	Str*  bp;
:f	Fenter("daReqRpl");
	if (bp = &sp->ibuf) {
:5		V5 "Init ibuf for srvr %s",DspSV(sp->name) V;
		initBuf(sp,bp,RplMax);
	}
:5	V5 "Request: %s",DspSP(rq) V;
:5	V5 "Require: %s",Dspp(ip) V;
	write(sp->sock,rq->v,rq->l);
	if (dp && dp->l > 0) {
:5		V5 "---Data: %s",Dspp(ip) V;
		write(sp->sock,dp->v,dp->l);
		write(sp->sock,"\n",1);		/* To ensure flushing */
	}
	sp->lasto = time(0L);
	MinStrMF(rp,RplMax+1,"reply");
	rp->l = 0;
	rp->p = rp->v;
	n = strlen(ip);
loop:
	if ((daGetSrvrRpl(sp,rp,-1)) < 0) {
:2		V2 "Request %s FAILED.",DspSP(rq) V;
		Fail;
	}
:2	V2 "Request %s got %s",DspSP(rq),DspSP(rp) V;
	if ((n > 0) &&  strncasecmp(ip,rp->v,n)) {
:2		V2 "Init %s doesn't match reply %s",Dspp(ip),DspSP(rp) V;
		Loop;
	}
done:
:f	Fexit;
	return rp;
fail:
:f	Fexit;
	return 0;
}

/*
* Read data from a server's buffer.  When we stop is determined by
* the value of n:  If n>0, we read n bytes.  If n <= 0, we return
* when we find a newline.
*/
int
daGetSrvrRpl(sp,rp,n)
	Srvr* sp;	/* Which server to read from */
	Str*  rp;	/* Where to put the results */
	int   n;	/* When and how to stop */
{	int   c;
	int   e=0;
	Str*  bp;
:f	Fenter("daGetSrvrRpl");
	rp->l = 0;
	bp = &sp->ibuf;
	while ((bp->p < bp->v + bp->l) && (*bp->p == '\n')) {
:5		V5 "Discard newline from input buffer." V;
		bp->p++;
	}
	while (1) {				/* Read until we get enough data */
:8		V8 "BUF: %s",Dspp(bp->p) V;
		if (bp->p >= bp->v + bp->l) {	/* Need to read more data */
:7			V7 "Before read(%d,%08lX,%d)",sp->sock,bp->v,RplMax V;
			if ((n = read(sp->sock,bp->v,RplMax)) >= 0) {
				bp->l = n;
				bp->p = bp->v;
			} else {
				e = errno;
:5				V5 "Got %d [Err %d=%s=%s] from fd %d srvr %s",n,Errinfo,sp->sock,DspSV(sp->name) V;
				Fail;
			}
		}
		c = rp->v[rp->l++] = *bp->p++;
		if ((n > 0 && rp->l >= n) || (c == '\n')) {
:6			V6 "Quit at byte %d = %02X='%c'",rp->l,B8(c),Dsp(c) V;
			Done;
		}
	}
done:
:5	V5 "Return %s",DspSP(rp) V;
:f	Fexit;
	return rp->l;
fail:
	errno = e;
:f	Fexit;
	return -1;
}
